=== modified file 'NEWS'
--- NEWS	2009-03-30 05:50:28 +0000
+++ NEWS	2009-03-31 00:12:10 +0000
@@ -194,6 +194,10 @@
   module documentation for ``bzrlib.smart.request`` for details.
   (Andrew Bennetts, Robert Collins)
 
+* ``Tree.get_symlink_target`` now always returns a unicode string result
+  or None. Previously it would return the bytes from reading the link
+  which could be in any arbitrary encoding. (Robert Collins)
+
 Testing
 *******
 

=== modified file 'bzrlib/tests/test_diff.py'
--- bzrlib/tests/test_diff.py	2009-03-23 14:59:43 +0000
+++ bzrlib/tests/test_diff.py	2009-03-31 00:12:10 +0000
@@ -704,7 +704,7 @@
             r'--- olddir/oldfile.*\n\+\+\+ newdir/newfile.*\n\@\@ -1,1 \+0,0'
              ' \@\@\n-old\n\n')
         self.assertContainsRe(self.differ.to_file.getvalue(),
-                              "=== target is 'new'\n")
+                              "=== target is u'new'\n")
 
     def test_diff_directory(self):
         self.build_tree(['new-tree/new-dir/'])

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2009-03-27 04:10:25 +0000
+++ bzrlib/workingtree.py	2009-03-31 00:12:10 +0000
@@ -969,7 +969,8 @@
         return file_id
 
     def get_symlink_target(self, file_id):
-        return os.readlink(self.id2abspath(file_id).encode(osutils._fs_enc))
+        return os.readlink(self.id2abspath(file_id).encode(osutils._fs_enc)
+            ).decode(osutils._fs_enc)
 
     @needs_write_lock
     def subsume(self, other_tree):

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2009-03-27 04:10:25 +0000
+++ bzrlib/workingtree_4.py	2009-03-31 00:12:10 +0000
@@ -1739,10 +1739,9 @@
         if entry[1][parent_index][0] != 'l':
             return None
         else:
-            # At present, none of the tree implementations supports non-ascii
-            # symlink targets. So we will just assume that the dirstate path is
-            # correct.
-            return entry[1][parent_index][1]
+            target = entry[1][parent_index][1]
+            target = target.decode('utf8')
+            return target
 
     def get_revision_id(self):
         """Return the revision id for this tree."""

